# NXP Secure Provisioning SDK

**Secure Provisioning SDK (SPSDK)** enables connection and communication with target devices for purposes of secure provisioning and programming. Delivered as python library with command-line applications for direct utilization.

![](https://github.com/NXPmicro/spsdk/raw/master/docs/_static/images/spsdk-architecture.png)

## Links

* [GitHub](https://github.com/NXPmicro/spsdk)
* [PyPi](https://pypi.org/project/spsdk/)
* [Documentation](https://spsdk.readthedocs.io)
* [Project page](https://www.nxp.com/design/design-center/software/development-software/secure-provisioning-sdk-spsdk:SPSDK)

## Supported Devices

|SPSDK name|               Category                |                                                                                                                                    Weblink                                                                                                                                    |Latest Revision|
|----------|---------------------------------------|-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|---------------|
|k32w1xx   |Wireless Connectivity                  |[Link to nxp.com](https://www.nxp.com/products/wireless/multiprotocol-mcus/tri-core-secure-and-ultra-low-power-mcu-for-matter-over-thread-and-bluetooth-le-5-3:K32W148)                                                                                                        |a2             |
|kw45xx    |Wireless Connectivity                  |[Link to nxp.com](https://www.nxp.com/products/wireless/bluetooth-low-energy/32-bit-bluetooth-5-3-long-range-mcus-with-can-fd-and-lin-bus-options-arm-cortex-m33-core:KW45)                                                                                                    |a2             |
|lpc550x   |LPC5500 Series                         |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/lpc5500-cortex-m33/lpc550x-s0x-baseline-arm-cortex-m33-based-microcontroller-family:LPC550x)                                                          |a0             |
|lpc551x   |LPC5500 Series                         |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/lpc5500-cortex-m33/lpc551x-s1x-baseline-arm-cortex-m33-based-microcontroller-family:LPC551X-S1X)                                                      |a0             |
|lpc552x   |LPC5500 Series                         |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/lpc5500-cortex-m33/lpc552x-s2x-mainstream-arm-cortex-m33-based-microcontroller-family:LPC552x-S2x)                                                    |1b             |
|lpc553x   |LPC5500 Series                         |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/lpc5500-arm-cortex-m33/lpc553x-s3x-advanced-analog-armcortex-m33-based-mcu-family:LPC553x)                                                            |1a             |
|lpc55s0x  |LPC5500 Series                         |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/lpc5500-cortex-m33/lpc550x-s0x-baseline-arm-cortex-m33-based-microcontroller-family:LPC550x)                                                          |a1             |
|lpc55s1x  |LPC5500 Series                         |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/lpc5500-cortex-m33/lpc551x-s1x-baseline-arm-cortex-m33-based-microcontroller-family:LPC551X-S1X)                                                      |a1             |
|lpc55s2x  |LPC5500 Series                         |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/lpc5500-cortex-m33/lpc552x-s2x-mainstream-arm-cortex-m33-based-microcontroller-family:LPC552x-S2x)                                                    |a1             |
|lpc55s3x  |LPC5500 Series                         |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/lpc5500-arm-cortex-m33/lpc553x-s3x-advanced-analog-armcortex-m33-based-mcu-family:LPC553x)                                                            |a1             |
|lpc55s6x  |LPC5500 Series                         |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/lpc5500-cortex-m33/high-efficiency-arm-cortex-m33-based-microcontroller-family:LPC55S6x)                                                              |a1             |
|mc56f816xx|Digital Signal Controller              |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/additional-mpu-mcus-architectures/digital-signal-controllers/32-bit-56800ex-ef-core/up-to-100mhz-digital-signal-controllers-with-dsass-and-operational-amplifier:MC56F81xxx)                    |b1             |
|mc56f817xx|Digital Signal Controller              |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/additional-mpu-mcus-architectures/digital-signal-controllers/32-bit-56800ex-ef-core/up-to-100mhz-digital-signal-controllers-with-dsass-and-operational-amplifier:MC56F81xxx)                    |b1             |
|mc56f818xx|Digital Signal Controller              |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/additional-mpu-mcus-architectures/digital-signal-controllers/32-bit-56800ex-ef-core/up-to-100mhz-digital-signal-controllers-with-dsass-and-operational-amplifier:MC56F81xxx)                    |b1             |
|mcxa142   |General Purpose Processor              |[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a0             |
|mcxa143   |General Purpose Processor              |[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a0             |
|mcxa144   |General Purpose Processor              |[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a0             |
|mcxa145   |General Purpose Processor              |[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a0             |
|mcxa146   |General Purpose Processor              |[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a0             |
|mcxa152   |General Purpose Processor              |[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a0             |
|mcxa153   |General Purpose Processor              |[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a0             |
|mcxa154   |General Purpose Processor              |[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a0             |
|mcxa155   |General Purpose Processor              |[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a0             |
|mcxa156   |General Purpose Processor              |[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a0             |
|mcxn23x   |MCX Industrial and IoT Microcontrollers|[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a0             |
|mcxn54x   |MCX Industrial and IoT Microcontrollers|[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/mcx-arm-cortex-m/mcx-n-series/mcx-n94x-and-n54x-mcus-with-dual-core-arm-cortex-m33-edgelock-secure-subsystem-and-neural-processing-unit:MCX-N94X-N54X)|a1             |
|mcxn94x   |MCX Industrial and IoT Microcontrollers|[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/general-purpose-mcus/mcx-arm-cortex-m/mcx-n-series/mcx-n94x-and-n54x-mcus-with-dual-core-arm-cortex-m33-edgelock-secure-subsystem-and-neural-processing-unit:MCX-N94X-N54X)|a1             |
|mcxw71xx  |Wireless Connectivity                  |[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a2             |
|mwct2x12  |Wireless Power                         |[Link to nxp.com](https://www.nxp.com/products/power-management/wireless-power:WIRCHA_ICS)                                                                                                                                                                                     |b1             |
|mwct2xd2  |Wireless Power                         |[Link to nxp.com](https://www.nxp.com/products/power-management/wireless-power:WIRCHA_ICS)                                                                                                                                                                                     |b1             |
|mwct2xxxs |Wireless Power                         |[Link to nxp.com](https://www.nxp.com/products/power-management/wireless-power/mwct2xxxs-microcontroller-for-wireless-charging-transmitter-ics:MWCT2xxxS)                                                                                                                      |a0             |
|mx8ulp    |i.MX 8 Applications Processors         |[Link to nxp.com](https://www.nxp.com)                                                                                                                                                                                                                                         |a0             |
|mx93      |i.MX 9 Applications Processors         |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-processors/i-mx-applications-processors/i-mx-9-processors/i-mx-93-applications-processor-family-arm-cortex-a55-ml-acceleration-power-efficient-mpu:i.MX93)                                  |a1             |
|nhs52sxx  |Wireless Connectivity                  |[Link to nxp.com](https://www.nxp.com/products/wireless-connectivity/bluetooth-low-energy/nhs52s04-ultra-low-power-bluetooth-low-energy-solution-with-arm-cortex-m33-trustzone-for-medical-iot:NHS52S04)                                                                       |a1             |
|rt1010    |i.MX RT Crossover MCUs                 |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/i-mx-rt-crossover-mcus/i-mx-rt1010-crossover-mcu-with-arm-cortex-m7-core:i.MX-RT1010)                                                                                      |a0             |
|rt1015    |i.MX RT Crossover MCUs                 |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/i-mx-rt-crossover-mcus/i-mx-rt1015-crossover-mcu-with-arm-cortex-m7-core-operating-up-to-500-mhz:i.MX-RT1015)                                                              |a0             |
|rt102x    |i.MX RT Crossover MCUs                 |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/i-mx-rt-crossover-mcus/i-mx-rt1020-crossover-mcu-with-arm-cortex-m7-core:i.MX-RT1020)                                                                                      |a0             |
|rt104x    |i.MX RT Crossover MCUs                 |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/i-mx-rt-crossover-mcus/i-mx-rt1040-crossover-mcu-with-arm-cortex-m7-core-operating-up-to-600-mhz-and-extended-temperature-range:i.MX-RT1040)                               |a0             |
|rt105x    |i.MX RT Crossover MCUs                 |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/i-mx-rt-crossover-mcus/i-mx-rt1050-crossover-mcu-with-arm-cortex-m7-core:i.MX-RT1050)                                                                                      |a0             |
|rt106x    |i.MX RT Crossover MCUs                 |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/i-mx-rt-crossover-mcus/i-mx-rt1060-crossover-mcu-with-arm-cortex-m7-core:i.MX-RT1060)                                                                                      |a0             |
|rt116x    |i.MX RT Crossover MCUs                 |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/i-mx-rt-crossover-mcus/i-mx-rt1160-crossover-mcu-dual-core-arm-cortex-m7-and-cortex-m4:i.MX-RT1160)                                                                        |a0             |
|rt117x    |i.MX RT Crossover MCUs                 |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/i-mx-rt-crossover-mcus/i-mx-rt1170-crossover-mcu-family-first-ghz-mcu-with-arm-cortex-m7-and-cortex-m4-cores:i.MX-RT1170)                                                  |a0             |
|rt118x    |i.MX RT Crossover MCUs                 |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/i-mx-rt-crossover-mcus/i-mx-rt1180-crossover-mcu-dual-core-arm-cortex-m7-and-cortex-m33-with-tsn-switch:i.MX-RT1180)                                                       |b0             |
|rt5xx     |i.MX RT Crossover MCUs                 |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/i-mx-rt-crossover-mcus/i-mx-rt500-crossover-mcu-with-arm-cortex-m33-core:i.MX-RT500)                                                                                       |b0             |
|rt6xx     |i.MX RT Crossover MCUs                 |[Link to nxp.com](https://www.nxp.com/products/processors-and-microcontrollers/arm-microcontrollers/i-mx-rt-crossover-mcus/i-mx-rt600-crossover-mcu-with-arm-cortex-m33-and-dsp-cores:i.MX-RT600)                                                                              |b0             |
|rw61x     |Wireless Connectivity                  |[Link to nxp.com](https://www.nxp.com/products/wireless/wi-fi-plus-bluetooth-plus-802-15-4/wireless-mcu-with-integrated-tri-radiobr1x1-wi-fi-6-plus-bluetooth-low-energy-5-3-802-15-4:RW612)                                                                                   |a2             |
## Supported environments

Windows 10 and 11, 64bit
Ubuntu 22.04.1 LTS
Mac OS Sonoma 14

## Usage

- See [installation](https://spsdk.readthedocs.io/en/latest/usage/installation.html) guide
- See [examples](https://github.com/nxp-mcuxpresso/spsdk/tree/master/examples) directory
- See [application](https://github.com/nxp-mcuxpresso/spsdk/tree/master/spsdk/apps) directory

---

## Dependencies

The core dependencies are included in [requirements.txt](https://github.com/nxp-mcuxpresso/spsdk/blob/master/requirements.txt).

The dependencies for the development and testing are included in [requirements-develop.txt](https://github.com/nxp-mcuxpresso/spsdk/blob/master/requirements-develop.txt).
